//OrbLauncher.cs

//audio
//datablock AudioProfile(OrbLauncherFireSound)
//{
//   filename    = "./OrbLauncherFire.wav";
//   description = AudioClosest3d;
//   preload = true;
//};

//datablock AudioProfile(OrbLauncherExplodeSound)
//{
//   filename    = "./Heavy_RL_blast.wav";
//   description = AudioDefault3d;
//   preload = true;
//};
//datablock AudioProfile(OrbLauncherLoopSound)
//{
//  filename    = "./OrbLauncherLoop.wav";
//   description = AudioCloseLooping3d;
//   preload = true;
//};
datablock AudioProfile(OrbLauncherBounceSound)
{
  filename    = "./OrbBounce1.wav";
   description = AudioDefault3d;
   preload = true;
};

//Trail Effect
datablock ParticleData(OrbTrailParticle)
{
   dragCoefficient      = 0;
   gravityCoefficient   = 0;
   windCoefficient      = 0;
   inheritedVelFactor   = 0;
   constantAcceleration = 0;
   lifetimeMS           = 50;
   lifetimeVarianceMS   = 0;
   textureName          = "base/data/particles/dot";
   spinSpeed     = 0;
   spinRandomMin = 0;
   spinRandomMax = 0;
   colors[0]     = "1 0.5 0.3 0.4";
   colors[1]     = "1 0.5 0 0.3";
   colors[2]     = "1 0.5 0 0";

   sizes[0]      = 0.5;
   sizes[1]      = 0.5;
   sizes[2]      = 0.2;

   times[0] = 0;
   times[1] = 0.04;
   times[2] = 1;

   useInvAlpha = false;
};
//Orb Effect
datablock ParticleData(OrbParticle)
{
   dragCoefficient      = 0;
   gravityCoefficient   = 0;
   windCoefficient      = 0;
   inheritedVelFactor   = 0;
   constantAcceleration = 0;
   lifetimeMS           = 18;
   lifetimeVarianceMS   = 0;
   textureName          = "base/data/particles/dot";
   spinSpeed     = 0;
   spinRandomMin = 0;
   spinRandomMax = 0;
   colors[0]     = "1 0.5 0.2 0.5";
   colors[1]     = "1 0.5 0.2 0.0";
//   colors[2]     = "1 0.5 0 0";

   sizes[0]      = 0.5;
   sizes[1]      = 0.5;
//   sizes[2]      = 0.5;

   times[0] = 0;
   times[1] = 1;
//   times[2] = 1;

   useInvAlpha = false;
};
datablock ParticleEmitterData(OrbTrailEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0;
   ejectionOffset = 0.08;
   thetaMin = 0;
   thetaMax = 180;
   phiReferenceVel = 1;
   phiVariance     = 360;
   overrideAdvance = false;
   particles = "OrbTrailParticle OrbParticle";
   uiName = "MAS Orb";
};
datablock ParticleData(OrbExplosionParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = -1.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0;
	lifetimeMS           = 150;
	lifetimeVarianceMS   = 20;
//	textureName			= "add-ons/projectile_radio_wave/bolt";
	textureName			= "base/data/particles/dot";
	spinSpeed			= 0;
	spinRandomMin		= 0;
	spinRandomMax		= 0;
	colors[0]     = "1.0 0.5 0.2 0.2";
	colors[1]     = "0.8 0.8 0.2 0.1";
	colors[2]     = "0.8 0.6 0.2 0";
	sizes[0]      = 0.3;
	sizes[1]      = 0.8;
	sizes[2]      = 2.0;

	times[0] 	= 0;
	times[1] 	= 0.7;
	times[2] 	= 1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(OrbExplosionEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0;
   ejectionOffset   = 0.06;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "OrbExplosionParticle";

   uiName = "MAS Orb Explosion";
//   emitterNode = TenthEmitterNode;
};

//Bounce Explosion effects//
datablock ParticleData(OrbBounceExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0;
	lifetimeMS           = 300;
	lifetimeVarianceMS   = 100;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "1 0.5 0.0 1.0";
	colors[1]     = "1 0.4 0.0 0.2";
//	colors[2]     = "0.8 0.8 0.8 0.2";
	sizes[0]      = 0.45;
	sizes[1]      = 0.1;
//	sizes[2]      = 15.0;

	times[0] = 0.0;
	times[1] = 1.0;

	useInvAlpha = false;
};

datablock ParticleEmitterData(OrbBounceExplosionEmitter)
{
	lifeTimeMS = 100;
	 
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 5;
	velocityVariance = 0.0;
	ejectionOffset   = 0.0;
	thetaMin         = 89;
	thetaMax         = 90;
	phiReferenceVel  = 0;
	phiVariance      = 360;
	overrideAdvance = false;
	particles = "OrbBounceExplosionParticle";

//   uiName = "MAS Orb Explosion";
//   emitterNode = TenthEmitterNode;
};


/////////////////
//--Explosion--//
/////////////////
datablock ExplosionData(MASOrbExplosion)
{
//	explosionShape = "Add-Ons/Weapon_Rocket_Launcher/explosionSphere1.dts";

	soundProfile = radioWaveExplosionSound;

	lifeTimeMS = 80;

	particleEmitter = OrbExplosionEmitter;
	particleDensity = 40;
	particleRadius = 0.1;
//   emitter[0] = OrbExplosionEmitter;
//   emitter[1] = OrbLauncherExplosionFlareEmitter;

//   debris = OrbLauncherFlareDebris;
//   debrisNum = 50;
//   debrisNumVariance = 10;
//   debrisPhiMin = 0;
//   debrisPhiMax = 360;
//   debrisThetaMin = 0;
//   debrisThetaMax = 180;
//   debrisVelocity = 120;
//   debrisVelocityVariance = 30;
   
   faceViewer = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "2.0 1.0 1.0";
   camShakeAmp = "9.0 7.0 3.0";
   camShakeDuration = 0.7;
   camShakeRadius = 2.0;

   // Dynamic light
   lightStartRadius = 1;
   lightEndRadius = 2;
   lightStartColor = "1 0.5 0.6 1";
   lightEndColor = "1 0.5 0 0";

   damageRadius = 5;
   radiusDamage = 10;

   impulseRadius = 5;
   impulseForce = 1000;
};

////////////////////////
//--Bounce Explosion--//
////////////////////////
datablock ExplosionData(MASOrbBounceExplosion)
{
//   explosionShape = "";
	soundProfile = OrbLauncherBounceSound;

	lifeTimeMS = 60;

	emitter[0] = OrbBounceExplosionEmitter;
	particleDensity = 60;
	particleRadius = 0.1;
//	emitter[1] = OrbLauncherBounceSparkEmitter;

//   debris = OrbLauncherFlareDebris;
//   debrisNum = 50;
//   debrisNumVariance = 10;
//   debrisPhiMin = 0;
//   debrisPhiMax = 360;
//   debrisThetaMin = 0;
//   debrisThetaMax = 180;
//   debrisVelocity = 120;
//   debrisVelocityVariance = 30;
   
   faceViewer = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "20.0 10.0 2.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.2;
   camShakeRadius = 2.0;

   // Dynamic light
   lightStartRadius = 1;
   lightEndRadius = 3;
   lightStartColor = "1 0.5 0 1";
   lightEndColor = "1 0.5 0 0";

   damageRadius = 5;
   radiusDamage = 35;

   impulseRadius = 5;
   impulseForce = 2000;
};


AddDamageType("OrbLauncherDirect",   '<bitmap:add-ons/Weapon_MAS_Orb_Launcher/CI_orb> %1',    '%2 <bitmap:add-ons/Weapon_MAS_Orb_Launcher/CI_orb> %1',1,1);
AddDamageType("OrbLauncherRadius",   '<bitmap:add-ons/Weapon_MAS_Orb_Launcher/CI_orb_radius> %1',    '%2 <bitmap:add-ons/Weapon_MAS_Orb_Launcher/CI_orb_radius> %1',1,0);
datablock ProjectileData(OrbLauncherProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 25;
   directDamageType = $DamageType::OrbLauncherDirect;
   radiusDamageType = $DamageType::OrbLauncherRadius;
   
   impactImpulse	   = 1000;
   verticalImpulse	   = 100;
   
   explosion           = MASOrbExplosion;
   bounceExplosion     = MASOrbBounceExplosion;
   particleEmitter     = OrbTrailEmitter;
   explodeOnDeath = true;
   explodeOnPlayerImpact = true;

   brickExplosionRadius = 1;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 4;             
   brickExplosionMaxVolume = 3;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

//   sound = OrbLauncherLoopSound;

   muzzleVelocity      = 50;
   velInheritFactor    = 1;

   armingDelay         = 1500;
   lifetime            = 1600;
   fadeDelay           = 1600;
   bounceElasticity    = 0.999;
   bounceFriction      = 0.1;
   isBallistic         = true;
   gravityMod = 0.4;

   hasLight    = true;
   lightRadius = 3;
   lightColor  = "1 0.5 0.0";

   uiName = "MAS Energy Orb";
};

//////////
// item //
//////////
datablock ItemData(OrbLauncherItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./OrbLauncher.dts";
	rotate = false;
	mass = 1;
	density = 0.2;

	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "MAS Orb L.";
	iconName = "./Icon_OrbLauncher_NEW";
	doColorShift = false;
	colorShiftColor = "0.100 0.500 0.250 1.000";

	 // Dynamic properties defined by the scripts
	image = OrbLauncherImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(OrbLauncherImage)
{
   // Basic Item properties
   shapeFile = "./OrbLauncher.dts";
   emap = true;

   doColorShift = false;
   colorShiftColor = "0.100 0.500 0.250 1.000";

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = OrbLauncherProjectile;
   projectileType = Projectile;

	//casing = rocketLauncherShellDebris;
//	shellExitDir        = "1.0 -1.3 1.0";
//	shellExitOffset     = "0 0 0";
//	shellExitVariance   = 15.0;	
//	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
//   minShotTime = 10;   //minimum time allowed between shots (needed to prevent equip/dequip exploit)

   //casing = " ";`

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]		 = "Ready";
	stateSound[0]					 = weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Charge";
	stateAllowImageChange[1]         = true;
	stateSequence[1]				 = "root";

	stateName[2]                    = "Charge";
	stateTransitionOnTimeout[2]     = "Fire";
	stateTimeoutValue[2]            = 0.2;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "charge";
//	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= OrbTrailEmitter;
	stateEmitterTime[2]				= 0.2;
	stateEmitterNode[2]				= "muzzleNode";
//	stateSound[2]					= radioWaveExplosionSound;

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "Reload";
	stateTimeoutValue[3]            = 0.5;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]			= true;
	stateEmitter[3]					= OrbBounceExplosionEmitter;
	stateEmitterTime[3]				= 0.1;
	stateEmitterNode[3]				= "muzzleNode";
	stateSound[3]					= radioWaveExplosionSound;

	stateName[4]					= "Reload";
//	stateSequence[4]                = "Reload";
	stateAllowImageChange[4]        = false;
	stateTimeoutValue[4]            = 0.01;
	stateWaitForTimeout[4]			= true;
//	stateTransitionOnTimeout[4]     = "Ready";
	stateTransitionOnTriggerUp[4]     = "Ready";

//	stateName[4]			= "Check";
//	stateTransitionOnTriggerUp[4]	= "StopFire";
//	stateTransitionOnTriggerDown[4]	= "Fire";

//	stateName[5]                    = "StopFire";
//	stateTransitionOnTimeout[5]     = "Ready";
//	stateTimeoutValue[5]            = 0.2;
//	stateAllowImageChange[5]        = false;
//	stateWaitForTimeout[5]		= true;
	//stateSequence[5]                = "Reload";
//	stateScript[5]                  = "onStopFire";
};

function OrbLauncherImage::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(3, plant);
		%obj.playThread(2, shiftAway);

	Parent::onFire(%this,%obj,%slot);	
//	%projectile = %this.projectile;
//	%spread = 0.02;
//	%shellcount = 1;

//	for(%shell=0; %shell<%shellcount; %shell++)
//	{
//		%vector = %obj.getMuzzleVector(%slot);
//		%objectVelocity = %obj.getVelocity();
//		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
//		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
//		%velocity = VectorAdd(%vector1,%vector2);
//		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
//		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
//		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
//		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
//		%velocity = MatrixMulVector(%mat, %velocity);
//
//		%p = new (%this.projectileType)()
//		{
//			dataBlock = %projectile;
//			initialVelocity = %velocity;
//			initialPosition = %obj.getMuzzlePoint(%slot);
//			sourceObject = %obj;
//			sourceSlot = %slot;
//			client = %obj.client;
//		};
//		MissionCleanup.add(%p);
//	}
//	return %p;

}
